cabal-version: 2.0

-- This file has been generated from package.yaml by hpack version 0.34.4.
--
-- see: https://github.com/sol/hpack

name:           cleveland
version:        0.1.1
synopsis:       Testing framework for Morley.
description:    This package provides an eDSL for testing contracts written in Michelson, Morley or Lorentz. These tests can be run on an emulated environment or on a real network.
category:       Blockchain
homepage:       https://gitlab.com/morley-framework/morley
bug-reports:    https://gitlab.com/morley-framework/morley/-/issues
author:         Serokell, Tocqueville Group
maintainer:     Serokell <hi@serokell.io>
copyright:      2019-2021 Tocqueville Group, 2021-2022 Oxhead Alpha
license:        MIT
license-file:   LICENSE
build-type:     Simple
extra-source-files:
    test/fixtures/addrValue.txt
    test/fixtures/addrValue.txt.license
    test/fixtures/intValue.txt
    test/fixtures/intValue.txt.license
extra-doc-files:
    README.md
    CHANGES.md

source-repository head
  type: git
  location: git@gitlab.com:morley-framework/morley.git

library
  exposed-modules:
      Hedgehog.Gen.Michelson
      Hedgehog.Gen.Michelson.Typed
      Hedgehog.Gen.Michelson.Untyped
      Hedgehog.Gen.Morley.Micheline
      Hedgehog.Gen.SizedList
      Hedgehog.Gen.Tezos.Address
      Hedgehog.Gen.Tezos.Core
      Hedgehog.Gen.Tezos.Crypto
      Hedgehog.Gen.Tezos.Crypto.BLS12381
      Hedgehog.Gen.Tezos.Crypto.Ed25519
      Hedgehog.Gen.Tezos.Crypto.P256
      Hedgehog.Gen.Tezos.Crypto.Secp256k1
      Hedgehog.Gen.Tezos.Crypto.Timelock
      Lorentz.Test.DupableScan
      Test.Cleveland
      Test.Cleveland.Doc
      Test.Cleveland.Doc.Common
      Test.Cleveland.Doc.Lorentz
      Test.Cleveland.Doc.Michelson
      Test.Cleveland.Ingredients
      Test.Cleveland.Instances
      Test.Cleveland.Internal.Abstract
      Test.Cleveland.Internal.Actions
      Test.Cleveland.Internal.Client
      Test.Cleveland.Internal.Exceptions
      Test.Cleveland.Internal.Hedgehog
      Test.Cleveland.Internal.Pure
      Test.Cleveland.Internal.Scenario
      Test.Cleveland.Lorentz
      Test.Cleveland.Lorentz.Consumer
      Test.Cleveland.Lorentz.Entrypoints
      Test.Cleveland.Lorentz.Import
      Test.Cleveland.Lorentz.Internal.Entrypoints
      Test.Cleveland.Lorentz.Requester
      Test.Cleveland.Lorentz.Ticketer
      Test.Cleveland.Lorentz.Types
      Test.Cleveland.Michelson
      Test.Cleveland.Michelson.Dummy
      Test.Cleveland.Michelson.Entrypoints
      Test.Cleveland.Michelson.Import
      Test.Cleveland.Michelson.Internal.Entrypoints
      Test.Cleveland.Michelson.Unit
      Test.Cleveland.Tasty
      Test.Cleveland.Tasty.Internal
      Test.Cleveland.Tasty.Internal.Options
      Test.Cleveland.Tasty.Internal.Report
      Test.Cleveland.Util
  other-modules:
      Paths_cleveland
  autogen-modules:
      Paths_cleveland
  hs-source-dirs:
      src
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DefaultSignatures
      DeriveAnyClass
      DeriveDataTypeable
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      EmptyCase
      FlexibleContexts
      FlexibleInstances
      GADTs
      GeneralizedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      NegativeLiterals
      NumDecimals
      NumericUnderscores
      OverloadedLabels
      OverloadedStrings
      PatternSynonyms
      PolyKinds
      QuantifiedConstraints
      QuasiQuotes
      RankNTypes
      RecordWildCards
      RecursiveDo
      ScopedTypeVariables
      StandaloneDeriving
      StandaloneKindSignatures
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      UndecidableSuperClasses
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-prepositive-qualified-module -Wno-missing-safe-haskell-mode -Wno-unused-packages
  build-depends:
      HUnit
    , MonadRandom
    , aeson
    , base-noprelude >=4.7 && <5
    , bytestring
    , constraints >=0.11
    , containers
    , criterion
    , cryptonite
    , data-default
    , directory
    , either
    , exceptions
    , file-embed
    , fmt
    , hedgehog >=1.0.3
    , hex-text
    , hspec
    , hspec-expectations
    , lens
    , lorentz
    , morley
    , morley-client
    , morley-prelude
    , mtl
    , named
    , o-clock
    , optparse-applicative
    , safe-exceptions
    , servant-client-core
    , singletons
    , statistics
    , tagged
    , tasty >=1.4
    , tasty-ant-xml
    , tasty-hedgehog
    , tasty-hunit-compat
    , template-haskell
    , text
    , time
    , with-utf8
  default-language: Haskell2010

test-suite cleveland-test
  type: exitcode-stdio-1.0
  main-is: Main.hs
  other-modules:
      TestSuite.Cleveland.AddressRevealing
      TestSuite.Cleveland.Assertions
      TestSuite.Cleveland.BalanceCheck
      TestSuite.Cleveland.BatchOperation
      TestSuite.Cleveland.BatchTransferCheck
      TestSuite.Cleveland.BlockIntervalGetter
      TestSuite.Cleveland.BytesSigning
      TestSuite.Cleveland.CallStack
      TestSuite.Cleveland.ChainIdGet
      TestSuite.Cleveland.ContractAllocation
      TestSuite.Cleveland.DFS
      TestSuite.Cleveland.Emulated
      TestSuite.Cleveland.Entrypoints
      TestSuite.Cleveland.ExpectFailure
      TestSuite.Cleveland.FailureLogs
      TestSuite.Cleveland.Import
      TestSuite.Cleveland.InitialState
      TestSuite.Cleveland.Level
      TestSuite.Cleveland.Lorentz.Contracts.ContractAllocator
      TestSuite.Cleveland.Lorentz.Entrypoints
      TestSuite.Cleveland.MismatchError
      TestSuite.Cleveland.NewAddressCheck
      TestSuite.Cleveland.OperationReplay
      TestSuite.Cleveland.PrefixNetworkScenario
      TestSuite.Cleveland.PrettyFailWith
      TestSuite.Cleveland.PublicKeyToAddress
      TestSuite.Cleveland.RefillableAddress
      TestSuite.Cleveland.RunCode
      TestSuite.Cleveland.StorageCheck
      TestSuite.Cleveland.StorageWithBigMaps
      TestSuite.Cleveland.Tasty
      TestSuite.Cleveland.Tasty.Report
      TestSuite.Cleveland.Tasty.Report.Examples
      TestSuite.Cleveland.Time
      TestSuite.Cleveland.TransferCheck
      TestSuite.Cleveland.UsedFramework
      TestSuite.Cleveland.Util
      TestSuite.Cleveland.VotingPower
      TestSuite.Cleveland.WithMoneybag
      TestSuite.Cleveland.WithSender
      TestSuite.Util
      Tree
      Test.Util.Contracts
      Paths_cleveland
  hs-source-dirs:
      test
      test-common
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DefaultSignatures
      DeriveAnyClass
      DeriveDataTypeable
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      EmptyCase
      FlexibleContexts
      FlexibleInstances
      GADTs
      GeneralizedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      NegativeLiterals
      NumDecimals
      NumericUnderscores
      OverloadedLabels
      OverloadedStrings
      PatternSynonyms
      PolyKinds
      QuantifiedConstraints
      QuasiQuotes
      RankNTypes
      RecordWildCards
      RecursiveDo
      ScopedTypeVariables
      StandaloneDeriving
      StandaloneKindSignatures
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      UndecidableSuperClasses
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-prepositive-qualified-module -Wno-missing-safe-haskell-mode -Wno-unused-packages -threaded -eventlog -rtsopts "-with-rtsopts=-N -A64m -AL256m"
  build-tool-depends:
      tasty-discover:tasty-discover
  build-depends:
      base-noprelude >=4.7 && <5
    , cleveland
    , directory
    , either
    , filepath
    , fmt
    , hedgehog >=1.0.3
    , hspec-expectations
    , lens
    , lorentz
    , morley
    , morley-client
    , morley-prelude
    , named
    , o-clock
    , servant-client
    , tasty
    , tasty-hedgehog
    , tasty-hunit-compat
    , temporary
    , text
    , time
  default-language: Haskell2010

test-suite lorentz-test
  type: exitcode-stdio-1.0
  main-is: Main.hs
  other-modules:
      Test.Doc
      Test.DocTest
      Test.Lorentz.Base
      Test.Lorentz.BLS12381
      Test.Lorentz.Case
      Test.Lorentz.Conditionals
      Test.Lorentz.ContractRegistry
      Test.Lorentz.CustomArith
      Test.Lorentz.CustomValue
      Test.Lorentz.DeadCode
      Test.Lorentz.Doc.Positions
      Test.Lorentz.DupableScan
      Test.Lorentz.Entrypoints
      Test.Lorentz.Entrypoints.Doc
      Test.Lorentz.Errors
      Test.Lorentz.Errors.Numeric
      Test.Lorentz.Expr
      Test.Lorentz.Extensible
      Test.Lorentz.Instr.MapOption
      Test.Lorentz.Interpreter
      Test.Lorentz.Macro
      Test.Lorentz.MorleyLogs
      Test.Lorentz.Optimizer
      Test.Lorentz.Pack
      Test.Lorentz.Print
      Test.Lorentz.Product
      Test.Lorentz.ReferencedByName
      Test.Lorentz.Storage
      Test.Lorentz.StoreClass.ComplexRefs
      Test.Lorentz.StoreClass.SetSubmap
      Test.Lorentz.StoreClass.StorageEntrypoints
      Test.Lorentz.StoreClass.SubmapZoom
      Test.Lorentz.Tickets
      Test.Lorentz.Tickets.Contracts
      Test.Lorentz.Tickets.Helpers
      Test.Lorentz.Timelock
      Test.Lorentz.UParam
      Test.Lorentz.Views
      Test.Lorentz.ViewsImport
      Test.Tasty.TypeSpec
      Test.Util.Annotation
      Test.Util.TypeSpec
      Tree
      Test.Util.Contracts
      Paths_cleveland
  hs-source-dirs:
      lorentz-test
      test-common
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DefaultSignatures
      DeriveAnyClass
      DeriveDataTypeable
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      EmptyCase
      FlexibleContexts
      FlexibleInstances
      GADTs
      GeneralizedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      NegativeLiterals
      NumDecimals
      NumericUnderscores
      OverloadedLabels
      OverloadedStrings
      PatternSynonyms
      PolyKinds
      QuantifiedConstraints
      QuasiQuotes
      RankNTypes
      RecordWildCards
      RecursiveDo
      ScopedTypeVariables
      StandaloneDeriving
      StandaloneKindSignatures
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      UndecidableSuperClasses
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-prepositive-qualified-module -Wno-missing-safe-haskell-mode -Wno-unused-packages -threaded -eventlog -rtsopts "-with-rtsopts=-N -A64m -AL256m"
  build-tool-depends:
      tasty-discover:tasty-discover
  build-depends:
      HUnit
    , base-noprelude >=4.7 && <5
    , bimap
    , bytestring
    , cleveland
    , constraints
    , containers
    , directory
    , filepath
    , first-class-families
    , fmt
    , hedgehog >=1.0.3
    , lens
    , lorentz
    , morley
    , morley-prelude
    , singletons
    , spoon
    , tasty
    , tasty-hedgehog
    , tasty-hunit-compat
    , text
    , type-spec
    , unordered-containers
  default-language: Haskell2010

test-suite morley-client-test
  type: exitcode-stdio-1.0
  main-is: Main.hs
  other-modules:
      Test.Fee
      Test.RPCKeyRevealing
      Tree
      Test.Util.Contracts
      Paths_cleveland
  hs-source-dirs:
      morley-client-test
      test-common
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DefaultSignatures
      DeriveAnyClass
      DeriveDataTypeable
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      EmptyCase
      FlexibleContexts
      FlexibleInstances
      GADTs
      GeneralizedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      NegativeLiterals
      NumDecimals
      NumericUnderscores
      OverloadedLabels
      OverloadedStrings
      PatternSynonyms
      PolyKinds
      QuantifiedConstraints
      QuasiQuotes
      RankNTypes
      RecordWildCards
      RecursiveDo
      ScopedTypeVariables
      StandaloneDeriving
      StandaloneKindSignatures
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      UndecidableSuperClasses
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-prepositive-qualified-module -Wno-missing-safe-haskell-mode -Wno-unused-packages -threaded -eventlog -rtsopts "-with-rtsopts=-N -A64m -AL256m"
  build-tool-depends:
      tasty-discover:tasty-discover
  build-depends:
      HUnit
    , base-noprelude >=4.7 && <5
    , cleveland
    , cryptonite
    , directory
    , filepath
    , morley
    , morley-client
    , morley-prelude
    , tasty
    , tasty-hunit-compat
  default-language: Haskell2010

test-suite morley-test
  type: exitcode-stdio-1.0
  main-is: Main.hs
  other-modules:
      Test.Analyzer
      Test.AsRPC
      Test.Doc.Position
      Test.Entrypoints
      Test.Ext
      Test.Import
      Test.Integrational
      Test.Interpreter
      Test.Interpreter.Annotations
      Test.Interpreter.Apply
      Test.Interpreter.Auction
      Test.Interpreter.Balance
      Test.Interpreter.CallSelf
      Test.Interpreter.CallSelfAddress
      Test.Interpreter.ComparableSet
      Test.Interpreter.Compare
      Test.Interpreter.ComparePairs
      Test.Interpreter.Conditionals
      Test.Interpreter.ContractOp
      Test.Interpreter.CreateAndReverseOps
      Test.Interpreter.CreateAndTransfer
      Test.Interpreter.EnvironmentSpec
      Test.Interpreter.Print
      Test.Interpreter.Reference
      Test.Interpreter.SetDelegate
      Test.Interpreter.StackRef
      Test.Interpreter.StringCaller
      Test.Interpreter.TransferAndCreate
      Test.Interpreter.Views
      Test.Macro
      Test.Michelson.Parser.Value
      Test.Michelson.Runtime
      Test.Michelson.Show
      Test.Michelson.Text
      Test.Michelson.Typed.AnnotatedValue
      Test.Michelson.Typed.Convert
      Test.Michelson.Typed.Util
      Test.Michelson.Typed.Value
      Test.Morley.Expression
      Test.OpSize
      Test.Optimizer
      Test.Parser
      Test.Preprocess
      Test.Printer.Michelson
      Test.Serialization.Aeson
      Test.Serialization.Typed.Michelson
      Test.Serialization.Untyped.Michelson
      Test.Serialization.Util
      Test.Tezos.Address
      Test.Tezos.Core
      Test.Tezos.Crypto
      Test.Tezos.Crypto.BLS12381
      Test.Tezos.Crypto.Hash
      Test.Tezos.Crypto.Timelock
      Test.Typeable
      Test.Typecheck
      Test.Typecheck.Annotation
      Test.Untyped.Instr
      Test.Util.Hedgehog
      Test.Util.HUnit
      Test.Util.Parser
      Test.Util.TH
      Test.ValConversion
      Test.Views
      Tree
      Test.Util.Contracts
      Paths_cleveland
  hs-source-dirs:
      morley-test
      test-common
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DefaultSignatures
      DeriveAnyClass
      DeriveDataTypeable
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      EmptyCase
      FlexibleContexts
      FlexibleInstances
      GADTs
      GeneralizedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      NegativeLiterals
      NumDecimals
      NumericUnderscores
      OverloadedLabels
      OverloadedStrings
      PatternSynonyms
      PolyKinds
      QuantifiedConstraints
      QuasiQuotes
      RankNTypes
      RecordWildCards
      RecursiveDo
      ScopedTypeVariables
      StandaloneDeriving
      StandaloneKindSignatures
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      UndecidableSuperClasses
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-prepositive-qualified-module -Wno-missing-safe-haskell-mode -Wno-unused-packages -threaded -eventlog -rtsopts "-with-rtsopts=-N -A64m -AL256m"
  build-tool-depends:
      tasty-discover:tasty-discover
  build-depends:
      HUnit
    , aeson
    , aeson-pretty
    , aeson-qq
    , base-noprelude >=4.7 && <5
    , bytestring
    , cleveland
    , constraints
    , containers
    , data-default
    , directory
    , filepath
    , fmt
    , hedgehog >=1.0.3
    , hex-text
    , hspec
    , hspec-expectations
    , lens
    , lorentz
    , megaparsec >=7.0.0
    , morley
    , morley-client
    , morley-prelude
    , mtl
    , named
    , silently
    , singletons
    , syb
    , tasty
    , tasty-hedgehog
    , tasty-hspec
    , tasty-hunit-compat
    , template-haskell
    , text
    , unordered-containers
    , vinyl
    , with-utf8
  default-language: Haskell2010

benchmark morley-bench
  type: exitcode-stdio-1.0
  main-is: Main.hs
  other-modules:
      Paths_cleveland
  hs-source-dirs:
      morley-bench
  default-extensions:
      AllowAmbiguousTypes
      ApplicativeDo
      BangPatterns
      BlockArguments
      ConstraintKinds
      DataKinds
      DefaultSignatures
      DeriveAnyClass
      DeriveDataTypeable
      DeriveFoldable
      DeriveFunctor
      DeriveGeneric
      DeriveTraversable
      DerivingStrategies
      DerivingVia
      EmptyCase
      FlexibleContexts
      FlexibleInstances
      GADTs
      GeneralizedNewtypeDeriving
      ImportQualifiedPost
      LambdaCase
      MultiParamTypeClasses
      MultiWayIf
      NamedFieldPuns
      NegativeLiterals
      NumDecimals
      NumericUnderscores
      OverloadedLabels
      OverloadedStrings
      PatternSynonyms
      PolyKinds
      QuantifiedConstraints
      QuasiQuotes
      RankNTypes
      RecordWildCards
      RecursiveDo
      ScopedTypeVariables
      StandaloneDeriving
      StandaloneKindSignatures
      StrictData
      TemplateHaskell
      TupleSections
      TypeApplications
      TypeFamilies
      TypeOperators
      UndecidableInstances
      UndecidableSuperClasses
      ViewPatterns
  ghc-options: -Weverything -Wno-missing-exported-signatures -Wno-missing-import-lists -Wno-missed-specialisations -Wno-all-missed-specialisations -Wno-unsafe -Wno-safe -Wno-missing-local-signatures -Wno-monomorphism-restriction -Wno-implicit-prelude -Wno-prepositive-qualified-module -Wno-missing-safe-haskell-mode -Wno-unused-packages
  build-depends:
      base-noprelude >=4.7 && <5
    , cleveland
    , data-default
    , gauge
    , megaparsec >=7.0.0
    , morley
    , morley-prelude
    , with-utf8
  default-language: Haskell2010
